import poplib
import email
from email.header import decode_header

def p2txt(tpl):
    return "\n".join(tpl[1])

def salva_t(msg, fname):
    f = open(fname, 'w')
    f.write(msg)
    f.close()

def salva_msg(msg, fname):
    f = open(fname, 'w')
    f.write(msg.as_string())
    f.close()

def decode_subject(msg):
    "Return subject in a decoded fasion"

    subject = ''
    # decode returns a list; each element is a tuble (text, charset)
    for txt, charset in decode_header(msg.get('Subject')):
        if charset:
            subject += txt.decode(charset)
    return subject

pop_instance = poplib.POP3('mail.e-den.it')
pop_instance.user('pop@e-den.it')
pop_instance.pass_('pr555')

msg7_t = p2txt(pop_instance.retr(7))
msg6_t = p2txt(pop_instance.retr(6))
msg3_t = p2txt(pop_instance.retr(3))
msg7 = email.message_from_string(msg7_t)
msg3 = email.message_from_string(msg3_t)
msg6 = email.message_from_string(msg6_t)
salva_t(msg7_t, '/tmp/messaggio7.txt')
salva_t(msg3_t, '/tmp/messaggio3.txt')
salva_t(msg6_t, '/tmp/messaggio6.txt')
salva_msg(msg7, '/tmp/msg7.txt')
salva_msg(msg3, '/tmp/msg3.txt')
salva_msg(msg6, '/tmp/msg6.txt')
